diff -r 5e0d53cac617 trytond/modules/purchase/purchase.py
--- a/trytond/modules/purchase/purchase.py	Mon Sep 10 15:28:28 2012 +0200
+++ b/trytond/modules/purchase/purchase.py	Mon Sep 24 20:36:42 2012 +0200
@@ -2170,46 +1807,44 @@
             ])
     handle = StateTransition()
 
-    def default_ask(self, session, fields):
-        purchase_obj = Pool().get('purchase.purchase')
+    def default_ask(self, fields):
+        Purchase = Pool().get('purchase.purchase')
 
-        purchase = purchase_obj.browse(Transaction().context['active_id'])
-        skip_ids = set(x.id for x in purchase.invoices_ignored)
-        skip_ids.update(x.id for x in purchase.invoices_recreated)
+        purchase = Purchase(Transaction().context['active_id'])
+        skip = set(purchase.invoices_ignored)
+        skip.update(purchase.invoices_recreated)
         invoices = []
         for invoice in purchase.invoices:
-            if invoice.state == 'cancel' and invoice.id not in skip_ids:
+            if invoice.state == 'cancel' and invoice not in skip:
                 invoices.append(invoice.id)
         return {
             'to_recreate': invoices,
             'domain_invoices': invoices,
             }
 
-    def transition_handle(self, session):
-        purchase_obj = Pool().get('purchase.purchase')
-        to_recreate = [x.id for x in session.ask.recreate_invoices]
-        domain_invoices = [x.id for x in session.ask.domain_invoices]
+    def transition_handle(self):
+        Purchase = Pool().get('purchase.purchase')
+        to_recreate = self.ask.recreate_invoices
+        domain_invoices = self.ask.domain_invoices
 
-        purchase = purchase_obj.browse(Transaction().context['active_id'])
+        purchase = Purchase(Transaction().context['active_id'])
 
-        skip_ids = set(x.id for x in purchase.invoices_ignored)
-        skip_ids.update(x.id for x in purchase.invoices_recreated)
+        skip = set(purchase.invoices_ignored)
+        skip.update(purchase.invoices_recreated)
         invoices_ignored = []
         invoices_recreated = []
         for invoice in purchase.invoices:
-            if invoice.id not in domain_invoices or invoice.id in skip_ids:
+            if invoice not in domain_invoices or invoice in skip:
                 continue
             if invoice.id in to_recreate:
                 invoices_recreated.append(invoice.id)
             else:
                 invoices_ignored.append(invoice.id)
 
-        purchase_obj.write(purchase.id, {
+        Purchase.write([purchase], {
             'invoices_ignored': [('add', invoices_ignored)],
             'invoices_recreated': [('add', invoices_recreated)],
             })
 
-        purchase_obj.process([purchase.id])
+        Purchase.process([purchase])
         return 'end'
-
-HandleInvoiceException()
diff -r 5e0d53cac617 trytond/modules/purchase/stock.py
--- a/trytond/modules/purchase/stock.py	Mon Sep 10 15:28:28 2012 +0200
+++ b/trytond/modules/purchase/stock.py	Mon Sep 24 20:36:42 2012 +0200
@@ -7,23 +7,22 @@
 from trytond.transaction import Transaction
 from trytond.pyson import PYSONDecoder, PYSONEncoder
 
+__all__ = ['OpenProductQuantitiesByWarehouse']
+
 
 class OpenProductQuantitiesByWarehouse(Wizard):
-    _name = 'stock.product_quantities_warehouse'
+    __name__ = 'stock.product_quantities_warehouse'
 
-    def do_open_(self, session, action):
-        pool = Pool()
-        product_obj = pool.get('product.product')
-        product_supplier_obj = pool.get('purchase.product_supplier')
+    def do_open_(self, action):
+        Product = Pool().get('product.product')
 
         action, data = super(OpenProductQuantitiesByWarehouse,
-            self).do_open_(session, action)
+            self).do_open_(action)
 
-        product = product_obj.browse(Transaction().context['active_id'])
+        product = Product(Transaction().context['active_id'])
         if product.product_suppliers:
             product_supplier = product.product_suppliers[0]
-            supply_date = \
-                product_supplier_obj.compute_supply_date(product_supplier)
+            supply_date = product_supplier.compute_supply_date()
             if supply_date != datetime.date.max:
                 search_value = \
                     PYSONDecoder().decode(action['pyson_search_value'])
@@ -35,5 +34,3 @@
                 action['pyson_search_value'] = PYSONEncoder().encode(
                     search_value)
         return action, data
-
-OpenProductQuantitiesByWarehouse()
diff -r d165adfd31c2 trytond/modules/purchase_invoice_line_standalone/__init__.py
--- a/trytond/modules/purchase_invoice_line_standalone/__init__.py	Thu Jul 26 00:07:52 2012 +0200
+++ b/trytond/modules/purchase_invoice_line_standalone/__init__.py	Mon Sep 24 20:36:42 2012 +0200
@@ -1,5 +1,15 @@
 #This file is part of Tryton.  The COPYRIGHT file at the top level of
 #this repository contains the full copyright notices and license terms.
 
+from trytond.pool import Pool
 from .purchase import *
 from .invoice import *
+
+
+def register():
+    Pool.register(
+        Purchase,
+        PurchaseInvoiceLine,
+        PurchaseIgnoredInvoiceLine,
+        InvoiceLine,
+        module='purchase_invoice_line_standalone', type_='model')
diff -r d165adfd31c2 trytond/modules/purchase_invoice_line_standalone/invoice.py
--- a/trytond/modules/purchase_invoice_line_standalone/invoice.py	Thu Jul 26 00:07:52 2012 +0200
+++ b/trytond/modules/purchase_invoice_line_standalone/invoice.py	Mon Sep 24 20:36:42 2012 +0200
@@ -1,60 +1,56 @@
 #This file is part of Tryton.  The COPYRIGHT file at the top level
 #of this repository contains the full copyright notices and license terms.
-from trytond.model import ModelView, ModelSQL
 from trytond.transaction import Transaction
-from trytond.pool import Pool
+from trytond.pool import Pool, PoolMeta
 
+__all__ = ['InvoiceLine']
+__metaclass__ = PoolMeta
 
-class InvoiceLine(ModelSQL, ModelView):
-    _name = 'account.invoice.line'
 
-    def __init__(self):
-        super(InvoiceLine, self).__init__()
-        self._error_messages.update({
+class InvoiceLine:
+    __name__ = 'account.invoice.line'
+
+    @classmethod
+    def __setup__(cls):
+        super(InvoiceLine, cls).__setup__()
+        cls._error_messages.update({
             'delete_purchase_invoice_line': 'You can not delete ' \
                     'invoice lines that comes from a purchase!',
             })
 
-    def write(self, ids, vals):
-        purchase_obj = Pool().get('purchase.purchase')
+    @classmethod
+    def write(cls, lines, vals):
+        Purchase = Pool().get('purchase.purchase')
 
         if 'invoice' in vals:
-            if isinstance(ids, (int, long)):
-                ids = [ids]
-
-            purchase_ids = purchase_obj.search([
-                ('invoice_lines', 'in', ids),
-                ])
+            purchases = Purchase.search([
+                    ('invoice_lines', 'in', [l.id for l in lines]),
+                    ])
             if vals['invoice']:
-                purchase_obj.write(purchase_ids, {
+                Purchase.write(purchases, {
                     'invoices': [('add', vals['invoice'])],
                     })
             else:
-                purchases = purchase_obj.browse(purchase_ids)
                 for purchase in purchases:
-                    invoice_ids = list(set([x.invoice.id for x \
-                            in purchase.invoice_lines \
-                            if x.invoice and x.id in ids]) - \
-                            set([x.invoice.id for x \
-                            in purchase.invoice_lines \
-                            if x.invoice and x.id not in ids]))
-                    purchase_obj.write(purchase.id, {
+                    invoice_ids = list(set([x.invoice.id for x
+                                in purchase.invoice_lines
+                                if x.invoice and x.id in lines])
+                        - set([x.invoice.id for x
+                                in purchase.invoice_lines
+                                if x.invoice and x.id not in lines]))
+                    Purchase.write([purchase], {
                         'invoices': [('unlink', invoice_ids)],
                         })
 
-        return super(InvoiceLine, self).write(ids, vals)
+        return super(InvoiceLine, cls).write(lines, vals)
 
-    def delete(self, ids):
+    @classmethod
+    def delete(cls, lines):
         cursor = Transaction().cursor
-        if not ids:
-            return True
-        if isinstance(ids, (int, long)):
-            ids = [ids]
-        cursor.execute('SELECT id FROM purchase_invoice_line_rel ' \
-                'WHERE line IN (' + ','.join(['%s' for x in ids]) + ')',
-                ids)
-        if cursor.rowcount:
-            self.raise_user_error('delete_purchase_invoice_line')
-        return super(InvoiceLine, self).delete(ids)
-
-InvoiceLine()
+        if lines:
+            cursor.execute('SELECT id FROM purchase_invoice_line_rel ' \
+                    'WHERE line IN (' + ','.join(['%s' for x in lines]) + ')',
+                    [l.id for l in lines])
+            if cursor.rowcount:
+                cls.raise_user_error('delete_purchase_invoice_line')
+        super(InvoiceLine, cls).delete(lines)
diff -r d165adfd31c2 trytond/modules/purchase_invoice_line_standalone/purchase.py
--- a/trytond/modules/purchase_invoice_line_standalone/purchase.py	Thu Jul 26 00:07:52 2012 +0200
+++ b/trytond/modules/purchase_invoice_line_standalone/purchase.py	Mon Sep 24 20:36:42 2012 +0200
@@ -1,20 +1,23 @@
 #This file is part of Tryton.  The COPYRIGHT file at the top level
 #of this repository contains the full copyright notices and license terms.
-from trytond.model import ModelView, ModelSQL, fields
+from trytond.model import ModelSQL, fields
 from trytond.transaction import Transaction
-from trytond.pool import Pool
+from trytond.pool import Pool, PoolMeta
 
+__all__ = ['Purchase', 'PurchaseInvoiceLine', 'PurchaseIgnoredInvoiceLine']
+__metaclass__ = PoolMeta
 
-class Purchase(ModelSQL, ModelView):
-    _name = 'purchase.purchase'
 
+class Purchase:
+    __name__ = 'purchase.purchase'
     invoice_lines = fields.Many2Many('purchase.purchase-account.invoice.line',
             'purchase', 'line', 'Invoice Lines', readonly=True)
     invoice_lines_ignored = fields.Many2Many(
             'purchase.purchase-ignored-account.invoice.line',
             'purchase', 'invoice', 'Invoice Lines Ignored', readonly=True)
 
-    def init(self, module_name):
+    @classmethod
+    def __register__(cls, module_name):
         cursor = Transaction().cursor
         # Migration from 1.2: packing renamed into shipment
         cursor.execute("UPDATE ir_model_data "\
@@ -22,40 +25,39 @@
                 "WHERE fs_id like '%%packing%%' "\
                     "AND module = %s", (module_name,))
 
-        super(Purchase, self).init(module_name)
+        super(Purchase, cls).__register__(module_name)
 
-    def create_invoice(self, purchase):
-        invoice_obj = Pool().get('account.invoice')
-        invoice_line_obj = Pool().get('account.invoice.line')
+    def create_invoice(self):
+        pool = Pool()
+        Invoice = pool.get('account.invoice')
+        InvoiceLine = pool.get('account.invoice.line')
 
-        invoice_id = super(Purchase, self).create_invoice(purchase)
+        invoice = super(Purchase, self).create_invoice()
 
-        if invoice_id:
-            invoice = invoice_obj.browse(invoice_id)
-            line_ids = [x.id for x in invoice.lines]
+        if invoice:
+            invoice_line_ids = [l.id for l in invoice.lines]
             with Transaction().set_user(0, set_context=True):
-                invoice_line_obj.write(line_ids, {
+                InvoiceLine.write(invoice.lines, {
                     'invoice': None,
                     'invoice_type': invoice.type,
                     'party': invoice.party,
                     'currency': invoice.currency.id,
                     'company': invoice.company.id,
                     })
-            self.write(purchase.id, {
-                'invoices': [('unlink', invoice_id)],
-                'invoice_lines': [('add', line_ids)],
+            self.write([self], {
+                'invoices': [('unlink', [invoice.id])],
+                'invoice_lines': [('add', invoice_line_ids)],
                 })
             with Transaction().set_user(0, set_context=True):
-                invoice_obj.cancel([invoice_id])
-                invoice_obj.delete(invoice_id)
+                Invoice.cancel([invoice])
+                Invoice.delete([invoice])
             return None
-        return invoice_id
+        return invoice
 
-    def get_invoice_state(self, purchase):
-        state = super(Purchase, self).get_invoice_state(purchase)
-        skip_ids = set(x.id for x in purchase.invoice_lines_ignored)
-        invoice_lines = [l for l in purchase.invoice_lines
-            if l.id not in skip_ids]
+    def get_invoice_state(self):
+        state = super(Purchase, self).get_invoice_state()
+        skips = set(x.id for x in self.invoice_lines_ignored)
+        invoice_lines = [l for l in self.invoice_lines if l not in skips]
         if invoice_lines:
             if any(l.invoice and l.invoice.state == 'cancel'
                     for l in invoice_lines):
@@ -66,52 +68,44 @@
                 return 'paid'
         return state
 
-    def copy(self, ids, default=None):
+    @classmethod
+    def copy(cls, purchases, default=None):
         if default is None:
             default = {}
         default = default.copy()
         default['invoice_lines'] = None
         default['invoice_lines_ignored'] = None
-        return super(Purchase, self).copy(ids, default=default)
+        return super(Purchase, cls).copy(purchases, default=default)
 
-    def ignore_invoice_exception(self, purchase_id):
-        super(Purchase, self).ignore_invoice_exception(purchase_id)
-        purchase = self.browse(purchase_id)
-        invoice_line_ids = []
-        for invoice_line in purchase.invoice_lines:
+    def ignore_invoice_exception(self):
+        super(Purchase, self).ignore_invoice_exception()
+        invoice_lines = []
+        for invoice_line in self.invoice_lines:
             if invoice_line.invoice \
                     and invoice_line.invoice.state == 'cancel':
-                invoice_line_ids.append(invoice_line.id)
-        if invoice_line_ids:
-            self.write(purchase_id, {
+                invoice_lines.append(invoice_line)
+        if invoice_lines:
+            self.write([self], {
                     'invoice_lines_ignored': [
-                        ('add', x) for x in invoice_line_ids],
+                        ('add', x.id) for x in invoice_lines],
                     })
 
-Purchase()
-
 
 class PurchaseInvoiceLine(ModelSQL):
     'Purchase - Invoice Line'
-    _name = 'purchase.purchase-account.invoice.line'
+    __name__ = 'purchase.purchase-account.invoice.line'
     _table = 'purchase_invoice_line_rel'
-    _description = __doc__
     purchase = fields.Many2One('purchase.purchase', 'Purchase',
             ondelete='CASCADE', select=True, required=True)
     line = fields.Many2One('account.invoice.line', 'Invoice Line',
             ondelete='RESTRICT', select=True, required=True)
 
-PurchaseInvoiceLine()
-
 
 class PurchaseIgnoredInvoiceLine(ModelSQL):
     'Purchase - Ignored Invoice Line'
-    _name = 'purchase.purchase-ignored-account.invoice.line'
+    __name__ = 'purchase.purchase-ignored-account.invoice.line'
     _table = 'purchase_invoice_line_ignored_rel'
-    _description = __doc__
     purchase = fields.Many2One('purchase.purchase', 'Purchase',
             ondelete='CASCADE', select=True, required=True)
     invoice = fields.Many2One('account.invoice.line', 'Invoice Line',
             ondelete='RESTRICT', select=True, required=True)
-
-PurchaseIgnoredInvoiceLine()
diff -r 623b1e0a0127 trytond/modules/purchase_shipment_cost/__init__.py
--- a/trytond/modules/purchase_shipment_cost/__init__.py	Sat Sep 22 21:41:40 2012 +0200
+++ b/trytond/modules/purchase_shipment_cost/__init__.py	Mon Sep 24 20:36:42 2012 +0200
@@ -1,5 +1,14 @@
 #This file is part of Tryton.  The COPYRIGHT file at the top level of
 #this repository contains the full copyright notices and license terms.
 
+from trytond.pool import Pool
 from stock import *
 from carrier import *
+
+
+def register():
+    Pool.register(
+        ShipmentIn,
+        Move,
+        Carrier,
+        module='purchase_shipment_cost', type_='model')
diff -r 623b1e0a0127 trytond/modules/purchase_shipment_cost/carrier.py
--- a/trytond/modules/purchase_shipment_cost/carrier.py	Sat Sep 22 21:41:40 2012 +0200
+++ b/trytond/modules/purchase_shipment_cost/carrier.py	Mon Sep 24 20:36:42 2012 +0200
@@ -1,16 +1,18 @@
 #This file is part of Tryton.  The COPYRIGHT file at the top level of
 #this repository contains the full copyright notices and license terms.
-from trytond.model import Model, fields
+from trytond.model import fields
+from trytond.pool import PoolMeta
 
+__all__ = ['Carrier']
+__metaclass__ = PoolMeta
 
-class Carrier(Model):
-    _name = 'carrier'
 
+class Carrier:
+    __name__ = 'carrier'
     carrier_cost_allocation_method = fields.Selection([
             ('value', 'By Value'),
             ], 'Carrier Cost Allocation Method', required=True)
 
-    def default_carrier_cost_allocation_method(self):
+    @staticmethod
+    def default_carrier_cost_allocation_method():
         return 'value'
-
-Carrier()
diff -r 623b1e0a0127 trytond/modules/purchase_shipment_cost/stock.py
--- a/trytond/modules/purchase_shipment_cost/stock.py	Sat Sep 22 21:41:40 2012 +0200
+++ b/trytond/modules/purchase_shipment_cost/stock.py	Mon Sep 24 20:36:42 2012 +0200
@@ -6,13 +6,15 @@
 
 from trytond.model import Model, ModelView, Workflow, fields
 from trytond.pyson import Eval, Bool
-from trytond.pool import Pool
+from trytond.pool import Pool, PoolMeta
 from trytond.transaction import Transaction
 
+__all__ = ['ShipmentIn', 'Move']
+__metaclass__ = PoolMeta
 
-class ShipmentIn(Model):
-    _name = 'stock.shipment.in'
 
+class ShipmentIn:
+    __name__ = 'stock.shipment.in'
     carrier = fields.Many2One('carrier', 'Carrier', states={
             'readonly': Eval('state') != 'draft',
             }, on_change=['carrier', 'incoming_moves'],
@@ -24,102 +26,78 @@
             }, depends=['cost', 'state'])
     cost_currency_digits = fields.Function(fields.Integer(
             'Cost Currency Digits', on_change_with=['currency']),
-        'get_cost_currency_digits')
+        'on_change_with_cost_currency_digits')
     cost = fields.Numeric('Cost', digits=(16, Eval('cost_currency_digits', 2)),
         states={
             'readonly': ~Eval('state').in_(['draft', 'assigned', 'packed']),
             }, depends=['carrier', 'state', 'cost_currency_digits'])
 
-    def __init__(self):
-        super(ShipmentIn, self).__init__()
-        self.incoming_moves = copy.copy(self.incoming_moves)
-        if not self.incoming_moves.on_change:
-            self.incoming_moves.on_change = []
-        else:
-            self.incoming_moves.on_change = copy.copy(
-                self.incoming_moves.on_change)
+    @classmethod
+    def __setup__(cls):
+        super(ShipmentIn, cls).__setup__()
+        if not cls.incoming_moves.on_change:
+            cls.incoming_moves.on_change = []
         for fname in ('carrier', 'incoming_moves'):
-            if fname not in self.incoming_moves.on_change:
-                self.incoming_moves.on_change.append(fname)
-        self._rpc.setdefault('on_change_incoming_moves', False)
-        self.carrier = copy.copy(self.carrier)
-        self.carrier.on_change = copy.copy(self.carrier.on_change)
-        for fname in self.incoming_moves.on_change:
-            if fname not in self.carrier.on_change:
-                self.carrier.on_change.append(fname)
-        self._reset_columns()
+            if fname not in cls.incoming_moves.on_change:
+                cls.incoming_moves.on_change.append(fname)
+        for fname in cls.incoming_moves.on_change:
+            if fname not in cls.carrier.on_change:
+                cls.carrier.on_change.append(fname)
 
-    def on_change_with_cost_currency_digits(self, values):
-        currency_obj = Pool().get('currency.currency')
-        if values.get('cost_currency'):
-            currency = currency_obj.browse(values['cost_currency'])
-            return currency.digits
+    def on_change_with_cost_currency_digits(self, name=None):
+        if self.cost_currency:
+            return self.cost_currency.digits
         return 2
 
-    def get_cost_currency_digits(self, ids, name):
-        '''
-        Return the number of digits of the cost currency
-        '''
-        result = {}
-        for shipment in self.browse(ids):
-            if shipment.cost_currency:
-                result[shipment.id] = shipment.cost_currency.digits
-            else:
-                result[shipment.id] = 2
-        return result
-
-    def _get_carrier_context(self, values):
+    def _get_carrier_context(self):
         return {}
 
-    def on_change_carrier(self, values):
-        return self.on_change_incoming_moves(values)
+    def on_change_carrier(self):
+        return self.on_change_incoming_moves()
 
-    def on_change_incoming_moves(self, values):
-        pool = Pool()
-        carrier_obj = pool.get('carrier')
-        currency_obj = pool.get('currency.currency')
+    def on_change_incoming_moves(self):
+        Currency = Pool().get('currency.currency')
 
         try:
-            result = super(ShipmentIn, self).on_change_incoming_moves(values)
+            result = super(ShipmentIn, self).on_change_incoming_moves()
         except AttributeError:
             result = {}
-        if not values.get('carrier'):
+        if not self.carrier:
             return result
-        carrier = carrier_obj.browse(values['carrier'])
-        with Transaction().set_context(
-                self._get_carrier_context(values)):
-            cost, currency_id = carrier_obj.get_purchase_price(carrier)
+        with Transaction().set_context(self._get_carrier_context()):
+            cost, currency_id = self.carrier.get_purchase_price()
         result['cost'] = cost
         result['cost_currency'] = currency_id
         if currency_id:
-            currency = currency_obj.browse(currency_id)
+            currency = Currency(currency_id)
             result['cost_currency_digits'] = currency.digits
         else:
             result['cost_currency_digits'] = 2
         return result
 
-    def allocate_cost_by_value(self, shipment):
-        currency_obj = Pool().get('currency.currency')
-        move_obj = Pool().get('stock.move')
+    def allocate_cost_by_value(self):
+        pool = Pool()
+        Currency = pool.get('currency.currency')
+        Move = pool.get('stock.move')
 
-        if not shipment.cost:
+        if not self.cost:
             return
 
-        cost = currency_obj.compute(shipment.cost_currency, shipment.cost,
-            shipment.company.currency, round=False)
-        moves = [m for m in shipment.incoming_moves
+        cost = Currency.compute(self.cost_currency, self.cost,
+            self.company.currency, round=False)
+        moves = [m for m in self.incoming_moves
             if m.state not in ('done', 'cancel')]
 
         sum_value = 0
         unit_prices = {}
         for move in moves:
-            unit_price = currency_obj.compute(move.currency, move.unit_price,
-                shipment.company.currency, round=False)
+            unit_price = Currency.compute(move.currency, move.unit_price,
+                self.company.currency, round=False)
             unit_prices[move.id] = unit_price
             sum_value += unit_price * Decimal(str(move.quantity))
 
         costs = []
-        digit = move_obj.unit_price.digits[1]
+        digit = Move.unit_price.digits[1]
         exp = Decimal(str(10.0 ** -digit))
         difference = cost
         for move in moves:
@@ -145,66 +123,62 @@
 
         for cost in costs:
             move = cost['move']
-            unit_shipment_cost = currency_obj.compute(
-                shipment.company.currency, cost['unit_shipment_cost'],
+            unit_shipment_cost = Currency.compute(
+                self.company.currency, cost['unit_shipment_cost'],
                 move.currency, round=False)
             unit_shipment_cost = unit_shipment_cost.quantize(
                 exp, rounding=ROUND_HALF_EVEN)
-            move_obj.write(move.id, {
+            Move.write([move], {
                     'unit_price': move.unit_price + cost['unit_shipment_cost'],
                     'unit_shipment_cost': cost['unit_shipment_cost'],
                     })
 
+    @classmethod
     @ModelView.button
     @Workflow.transition('received')
-    def receive(self, ids):
-        carrier_obj = Pool().get('carrier')
-        for shipment in self.browse(ids):
+    def receive(cls, shipments):
+        Carrier = Pool().get('carrier')
+        for shipment in shipments:
             if shipment.carrier:
                 allocation_method = \
                     shipment.carrier.carrier_cost_allocation_method
             else:
                 allocation_method = \
-                    carrier_obj.default_carrier_cost_allocation_method()
-            getattr(self, 'allocate_cost_by_%s' % allocation_method)(shipment)
-        super(ShipmentIn, self).receive(ids)
+                    Carrier.default_carrier_cost_allocation_method()
+            getattr(shipment, 'allocate_cost_by_%s' % allocation_method)()
+        super(ShipmentIn, cls).receive(shipments)
 
-ShipmentIn()
 
-
-class Move(Model):
-    _name = 'stock.move'
-
+class Move:
+    __name__ = 'stock.move'
     unit_shipment_cost = fields.Numeric('Unit Shipment Cost', digits=(16, 4),
         readonly=True)
 
     # Split the shipment cost if account_stock_continental is installed
-    def _get_account_stock_move_lines(self, move, type_):
-        currency_obj = Pool().get('currency.currency')
-        move_lines = super(Move, self)._get_account_stock_move_lines(move,
-            type_)
+    def _get_account_stock_move_lines(self, type_):
+        pool = Pool()
+        AccountMoveLine = pool.get('account.move.line')
+        move_lines = super(Move, self)._get_account_stock_move_lines(type_)
         if (type_.startswith('in_')
-                and move.unit_shipment_cost
-                and move.shipment_in
-                and move.shipment_in.carrier):
-            shipment_cost = currency_obj.round(move.company.currency,
-                Decimal(str(move.quantity)) * move.unit_shipment_cost)
+                and self.unit_shipment_cost
+                and self.shipment_in
+                and self.shipment_in.carrier):
+            shipment_cost = self.company.currency.round(
+                Decimal(str(self.quantity)) * self.unit_shipment_cost)
             shipment_cost_account = \
-                move.shipment_in.carrier.carrier_product.account_expense_used
-            account_id = move.product.account_stock_supplier_used.id
+                self.shipment_in.carrier.carrier_product.account_expense_used
+            account = self.product.account_stock_supplier_used
             for move_line in move_lines:
-                if move_line['account'] == account_id:
-                    move_line['credit'] -= shipment_cost
-                    shipment_cost_line = {
-                        'name': move.rec_name,
-                        'debit': Decimal('0'),
-                        'credit': shipment_cost,
-                        'account': shipment_cost_account,
-                        }
+                if move_line.account == account:
+                    move_line.credit -= shipment_cost
+                    shipment_cost_line = AccountMoveLine(
+                        name=self.rec_name,
+                        debit=Decimal('0'),
+                        credit=shipment_cost,
+                        account=shipment_cost_account,
+                        )
                     move_lines.append(shipment_cost_line)
                     break
             else:
                 raise AssertionError('missing account_stock_supplier')
         return move_lines
-
-Move()
diff -r f3e24bd4d57e trytond/modules/sale/__init__.py
--- a/trytond/modules/sale/__init__.py	Tue Sep 11 15:23:08 2012 +0200
+++ b/trytond/modules/sale/__init__.py	Mon Sep 24 20:36:42 2012 +0200
@@ -1,6 +1,40 @@
 #This file is part of Tryton.  The COPYRIGHT file at the top level of
 #this repository contains the full copyright notices and license terms.
 
+from trytond.pool import Pool
 from .sale import *
 from .configuration import *
 from .invoice import *
+
+
+def register():
+    Pool.register(
+        Sale,
+        SaleInvoice,
+        SaleIgnoredInvoice,
+        SaleRecreatedInvoice,
+        SaleLine,
+        SaleLineTax,
+        SaleLineInvoiceLine,
+        SaleLineIgnoredMove,
+        SaleLineRecreatedMove,
+        Template,
+        Product,
+        ShipmentOut,
+        ShipmentOutReturn,
+        Move,
+        HandleShipmentExceptionAsk,
+        HandleInvoiceExceptionAsk,
+        Configuration,
+        Invoice,
+        InvoiceLine,
+        module='sale', type_='model')
+    Pool.register(
+        OpenCustomer,
+        HandleShipmentException,
+        HandleInvoiceException,
+        ReturnSale,
+        module='sale', type_='wizard')
+    Pool.register(
+        SaleReport,
+        module='sale', type_='report')
diff -r f3e24bd4d57e trytond/modules/sale/configuration.py
--- a/trytond/modules/sale/configuration.py	Tue Sep 11 15:23:08 2012 +0200
+++ b/trytond/modules/sale/configuration.py	Mon Sep 24 20:36:42 2012 +0200
@@ -3,12 +3,12 @@
 from trytond.model import ModelView, ModelSQL, ModelSingleton, fields
 from trytond.pyson import Eval, Bool
 
+__all__ = ['Configuration']
+
 
 class Configuration(ModelSingleton, ModelSQL, ModelView):
     'Sale Configuration'
-    _name = 'sale.configuration'
-    _description = __doc__
-
+    __name__ = 'sale.configuration'
     sale_sequence = fields.Property(fields.Many2One('ir.sequence',
             'Sale Reference Sequence', domain=[
                 ('company', 'in', [Eval('context', {}).get('company', 0),
@@ -29,5 +29,3 @@
                 ], 'Sale Shipment Method', states={
                 'required': Bool(Eval('context', {}).get('company', 0)),
                 }))
-
-Configuration()
